package ch.hslu.appe.gui;

import java.awt.EventQueue;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;

import java.awt.Font;

import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Insets;

import javax.swing.JPasswordField;

import ch.hslu.appe.usermanagement.webservice.AccessService;
import ch.hslu.appe.usermanagement.webservice.AccessServiceImplService;
import ch.hslu.appe.usermanagement.webservice.SessionDto;
import ch.hslu.appe.webservice.consumer.SessionHandler;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

/**
 * GUI Login.
 */
public class login extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private JTextField textLoginUser;
    private static login login;
    private JPasswordField passwordFieldLogin;
    private static AccessService accessService;
    private JLabel labelTitle;
    private JLabel labelLoginUser;
    private JButton buttonGo;
    private JButton btnAbbrechen;
    private JButton buttonWrongUser;
    private JButton buttonWrongPassword;

    /**
     * Launch the application.
     * @param args arguments
     */
    public static void main(final String[] args) {

        // Implement Webservice Access
        try {
            AccessServiceImplService accessServiceImpl = new AccessServiceImplService();
            accessService = accessServiceImpl.getAccessServiceImplPort();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Webservice ist nicht verfügbar!", "ERROR", JOptionPane.ERROR_MESSAGE);
            return;
        }

        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    login = new login();
                    login.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    /**
     * Create the frame.
     */
    public login() {

        // General
        setResizable(false);
        setTitle("Login");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 300, 259);

        // Main Panel
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        contentPane.setLayout(null);

        // Title Label
        labelTitle = new JLabel("Produktbestellung");
        labelTitle.setFont(new Font("Tekton Pro", Font.PLAIN, 36));
        labelTitle.setBounds(10, 11, 278, 37);
        contentPane.add(labelTitle);

        // User Label
        labelLoginUser = new JLabel("Benutzer:");
        labelLoginUser.setFont(new Font("Tahoma", Font.PLAIN, 14));
        labelLoginUser.setBounds(10, 87, 80, 14);
        contentPane.add(labelLoginUser);

        // User Textfield
        textLoginUser = new JTextField();
        textLoginUser.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(final FocusEvent arg0) {
                buttonWrongUser.setVisible(false);
            }
        });
        textLoginUser.addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(final KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    passwordFieldLogin.requestFocus();
                }
            }
        });
        textLoginUser.setFont(new Font("Tahoma", Font.PLAIN, 14));
        textLoginUser.setBounds(82, 86, 177, 20);
        contentPane.add(textLoginUser);
        textLoginUser.setColumns(10);

        // Password Label
        JLabel labelLoginPassword = new JLabel("Passwort:");
        labelLoginPassword.setFont(new Font("Tahoma", Font.PLAIN, 14));
        labelLoginPassword.setBounds(10, 138, 80, 14);
        contentPane.add(labelLoginPassword);

        // Password Textfield
        passwordFieldLogin = new JPasswordField();
        passwordFieldLogin.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(final FocusEvent e) {
                buttonWrongPassword.setVisible(false);
            }
        });
        passwordFieldLogin.addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(final KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    loginClient();
                }
            }
        });
        passwordFieldLogin.setFont(new Font("Tahoma", Font.PLAIN, 14));
        passwordFieldLogin.setBounds(82, 137, 177, 20);
        contentPane.add(passwordFieldLogin);

        // GO! Button
        buttonGo = new JButton("GO");
        buttonGo.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                loginClient();
            }
        });
        buttonGo.setFont(new Font("Tahoma", Font.PLAIN, 12));
        buttonGo.setBounds(195, 196, 89, 23);
        contentPane.add(buttonGo);

        // Cancel Button
        btnAbbrechen = new JButton("Abbrechen");
        btnAbbrechen.setMargin(new Insets(2, 2, 2, 2));
        btnAbbrechen.setFont(new Font("Tahoma", Font.PLAIN, 12));
        btnAbbrechen.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                login.dispose();
            }
        });
        btnAbbrechen.setBounds(96, 196, 89, 23);
        contentPane.add(btnAbbrechen);

        buttonWrongPassword = new JButton("");
        buttonWrongPassword.setMargin(new Insets(0, 0, 0, 0));
        buttonWrongPassword.setContentAreaFilled(false);
        buttonWrongPassword.setBorderPainted(false);
        buttonWrongPassword.setBorder(null);
        buttonWrongPassword.setIcon(new ImageIcon(this.getClass().getResource("../img/del_small.png")));
        buttonWrongPassword.setVisible(false);
        buttonWrongPassword.setBounds(263, 136, 25, 25);
        contentPane.add(buttonWrongPassword);

        buttonWrongUser = new JButton("");
        buttonWrongUser.setMargin(new Insets(0, 0, 0, 0));
        buttonWrongUser.setContentAreaFilled(false);
        buttonWrongUser.setBorderPainted(false);
        buttonWrongUser.setBorder(null);
        buttonWrongUser.setIcon(new ImageIcon(this.getClass().getResource("../img/del_small.png")));
        buttonWrongUser.setVisible(false);
        buttonWrongUser.setBounds(263, 85, 25, 25);
        contentPane.add(buttonWrongUser);
    }

    /**
     * Login.
     */
    private void loginClient() {
        // get password
        char[] pwd = passwordFieldLogin.getPassword();

        // check session
        SessionDto session = accessService.login(textLoginUser.getText(), new String(pwd));

        // if session not null then login
        if (session != null) {
            System.out.println("You're in! Session key is: " + session.getKey());
            SessionHandler.getInstance().setSessionKey(session.getKey());
            productOrder productOrderFrame = new productOrder();
            login.setVisible(false);
            productOrderFrame.setVisible(true);
        } else {
            passwordFieldLogin.setText("");
            buttonWrongUser.setVisible(true);
            buttonWrongPassword.setVisible(true);
        }
    }
}
