package ch.hslu.appe.order.webservice;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;

import ch.hslu.appe.usermanagement.webservice.AddressDto;
import ch.hslu.appe.usermanagement.webservice.UserDto;

/**
 * <p>
 * Java class for orderDto complex type.
 * <p>
 * The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="orderDto">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="customer" type="{http://webservice.order.appe.hslu.ch/}userDto"/>
 *         &lt;element name="deliverAddress" type="{http://webservice.order.appe.hslu.ch/}addressDto"/>
 *         &lt;element name="deliverCost" type="{http://www.w3.org/2001/XMLSchema}float"/>
 *         &lt;element name="deliverDate" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
 *         &lt;element name="deliverState" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="id" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="number" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="orderDate" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
 *         &lt;element name="orderPositions" type="{http://webservice.order.appe.hslu.ch/}orderPositionDto" maxOccurs="unbounded"/>
 *         &lt;element name="orderState" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="payState" type="{http://www.w3.org/2001/XMLSchema}int"/>
 *         &lt;element name="sales" type="{http://webservice.order.appe.hslu.ch/}userDto"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "orderDto", propOrder = { "customer", "deliverAddress", "deliverCost", "deliverDate", "deliverState",
        "id", "number", "orderDate", "orderPositions", "orderState", "payState", "sales" })
public class OrderDto {

    @XmlElement(required = true)
    protected UserDto customer;
    @XmlElement(required = true)
    protected AddressDto deliverAddress;
    protected float deliverCost;
    @XmlElement(required = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar deliverDate;
    protected int deliverState;
    protected int id;
    protected int number;
    @XmlElement(required = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar orderDate;
    @XmlElement(required = true)
    protected List<OrderPositionDto> orderPositions;
    protected int orderState;
    protected int payState;
    @XmlElement(required = true)
    protected UserDto sales;

    /**
     * Gets the value of the customer property.
     * @return possible object is {@link UserDto }
     */
    public UserDto getCustomer() {
        return customer;
    }

    /**
     * Gets the value of the deliverAddress property.
     * @return possible object is {@link AddressDto }
     */
    public AddressDto getDeliverAddress() {
        return deliverAddress;
    }

    /**
     * Gets the value of the deliverCost property.
     */
    public float getDeliverCost() {
        return deliverCost;
    }

    /**
     * Gets the value of the deliverDate property.
     * @return possible object is {@link XMLGregorianCalendar }
     */
    public XMLGregorianCalendar getDeliverDate() {
        return deliverDate;
    }

    /**
     * Gets the value of the deliverState property.
     */
    public int getDeliverState() {
        return deliverState;
    }

    /**
     * Gets the value of the id property.
     */
    public int getId() {
        return id;
    }

    /**
     * Gets the value of the number property.
     */
    public int getNumber() {
        return number;
    }

    /**
     * Gets the value of the orderDate property.
     * @return possible object is {@link XMLGregorianCalendar }
     */
    public XMLGregorianCalendar getOrderDate() {
        return orderDate;
    }

    /**
     * Gets the value of the orderPositions property.
     * <p>
     * This accessor method returns a reference to the live list, not a snapshot. Therefore any modification you make to
     * the returned list will be present inside the JAXB object. This is why there is not a <CODE>set</CODE> method for
     * the orderPositions property.
     * <p>
     * For example, to add a new item, do as follows:
     * 
     * <pre>
     * getOrderPositions().add(newItem);
     * </pre>
     * <p>
     * Objects of the following type(s) are allowed in the list {@link OrderPositionDto }
     */
    public List<OrderPositionDto> getOrderPositions() {
        if (orderPositions == null) {
            orderPositions = new ArrayList<OrderPositionDto>();
        }
        return this.orderPositions;
    }

    /**
     * Gets the value of the orderState property.
     */
    public int getOrderState() {
        return orderState;
    }

    /**
     * Gets the value of the payState property.
     */
    public int getPayState() {
        return payState;
    }

    /**
     * Gets the value of the sales property.
     * @return possible object is {@link UserDto }
     */
    public UserDto getSales() {
        return sales;
    }

    /**
     * Sets the value of the customer property.
     * @param value allowed object is {@link UserDto }
     */
    public void setCustomer(UserDto value) {
        this.customer = value;
    }

    /**
     * Sets the value of the deliverAddress property.
     * @param value allowed object is {@link AddressDto }
     */
    public void setDeliverAddress(AddressDto value) {
        this.deliverAddress = value;
    }

    /**
     * Sets the value of the deliverCost property.
     */
    public void setDeliverCost(float value) {
        this.deliverCost = value;
    }

    /**
     * Sets the value of the deliverDate property.
     * @param value allowed object is {@link XMLGregorianCalendar }
     */
    public void setDeliverDate(XMLGregorianCalendar value) {
        this.deliverDate = value;
    }

    /**
     * Sets the value of the deliverState property.
     */
    public void setDeliverState(int value) {
        this.deliverState = value;
    }

    /**
     * Sets the value of the id property.
     */
    public void setId(int value) {
        this.id = value;
    }

    /**
     * Sets the value of the number property.
     */
    public void setNumber(int value) {
        this.number = value;
    }

    /**
     * Sets the value of the orderDate property.
     * @param value allowed object is {@link XMLGregorianCalendar }
     */
    public void setOrderDate(XMLGregorianCalendar value) {
        this.orderDate = value;
    }

    /**
     * Sets the value of the orderState property.
     */
    public void setOrderState(int value) {
        this.orderState = value;
    }

    /**
     * Sets the value of the payState property.
     */
    public void setPayState(int value) {
        this.payState = value;
    }

    /**
     * Sets the value of the sales property.
     * @param value allowed object is {@link UserDto }
     */
    public void setSales(UserDto value) {
        this.sales = value;
    }

}
