package ch.hslu.appe.webservice.handler;

import java.io.IOException;
import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPConstants;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPHeaderElement;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

import ch.hslu.appe.webservice.consumer.SessionHandler;

public class AccessInjector implements SOAPHandler<SOAPMessageContext> {

    @Override
    public void close(MessageContext context) {

    }

    @Override
    public Set<QName> getHeaders() {

        return null;
    }

    @Override
    public boolean handleFault(SOAPMessageContext context) {

        return true;
    }

    @Override
    public boolean handleMessage(SOAPMessageContext context) {

        Boolean isRequest = (Boolean) context.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);

        // outbound message to server
        if (isRequest) {

            try {
                SOAPMessage soapMessagg = context.getMessage();
                SOAPEnvelope soapEnvelope = soapMessagg.getSOAPPart().getEnvelope();
                SOAPHeader soapHeader = soapEnvelope.getHeader();

                // add a header to the SOAP message
                if (soapHeader == null) {
                    soapHeader = soapEnvelope.addHeader();
                }

                // add a soap header, name as "ipAddress"
                QName qname = new QName("http://webservice.usermanagement.appe.hslu.ch/", "sessionkey");
                SOAPHeaderElement soapHeaderElement = soapHeader.addHeaderElement(qname);

                soapHeaderElement.setActor(SOAPConstants.URI_SOAP_ACTOR_NEXT);
                soapHeaderElement.addTextNode(SessionHandler.getInstance().getSessionKey());
                soapMessagg.saveChanges();

                // print the message, or log it...
                soapMessagg.writeTo(System.out);

            } catch (SOAPException e) {
                System.err.println(e);
            } catch (IOException e) {
                System.err.println(e);
            }

        }

        // continue other handler chain
        return true;
    }
}
